Draft Downgrade/sv: Difference between revisions

From FreeCAD Documentation
(Created page with "{{GuiCommand/se|Name=Draft_Downgrade|Workbenches=Skiss|MenuLocation=Draft -> Downgrade}}")
(Updating to match new version of source page)
 
(25 intermediate revisions by 4 users not shown)
Line 1: Line 1:
<languages/>
{{GuiCommand/se|Name=Draft_Downgrade|Workbenches=[[Draft Module/se|Skiss]]|MenuLocation=Draft -> Downgrade}}


{{Docnav
==Description==
|[[Draft_Upgrade|Upgrade]]
|[[Draft_WireToBSpline|WireToBSpline]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Upgrade.svg
|IconR=Draft_WireToBSpline.svg
|IconC=Workbench_Draft.svg
}}


<div class="mw-translate-fuzzy">
This tool downgrades selected objects in different ways. If no object is selected, you will be invited to select one.
{{GuiCommand/sv|Name=Draft Downgrade|Name/sv=Draft Downgrade|Workbenches=[[Draft_Workbench/sv|Draft]], [[Arch_Workbench/sv|Arch]]|MenuLocation=Draft -> Downgrade|Shortcut=D N|SeeAlso=[[Draft Upgrade/sv|Draft Upgrade]]}}
</div>

<span id="Description"></span>
==Beskrivning==

<div class="mw-translate-fuzzy">
Detta verktyg nedgraderar valda objekt på olika sätt. Om inget objekt är markerat, så kommer du att ombes att välja ett.
</div>


[[Image:Draft_Downgrade_example.jpg|400px]]
[[Image:Draft_Downgrade_example.jpg|400px]]
{{Caption|Two overlapping faces are downgraded to a Part Cut object, which is downgraded to a face. That face is then downgraded to a closed wire, which is finally downgraded to separate edges.}}


<span id="Usage"></span>
==How to use==
<div class="mw-translate-fuzzy">
==Bruk==
</div>


# Select one or more objects you widh to downgrade
# Optionally select one or more objects.
# There are several ways to invoke the command:
# Press the {{KEY|[[Image:Draft Downgrade.png|16px]] [[Draft Downgrade]]}} button or press {{KEY|D}} then {{KEY|N}} keys
#* Press the {{Button|[[Image:Draft_Downgrade.svg|16px]] [[Draft_Downgrade|Downgrade]]}} button.
#* Select the {{MenuCommand|Modification → [[Image:Draft_Downgrade.svg|16px]] Downgrade}} option from the menu.
#* Use the keyboard shortcut: {{KEY|D}} then {{KEY|N}}.
# If you have not yet selected an object: select an object in the [[3D_view|3D view]].


==Options==
==Scripting==


See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].
The selected objects are modified/downgraded, according to the following conditions (in order):
* if only one object is selected and it contains more than one face, each face becomes a separate object
* if there are more than one face in the selection, the subsequent objects are subtracted from the first one
* if there is only one face in the selection, it gets converted into a wire
* otherwise all wires found in the selection are exploded into single edges


To downgrade objects use the {{incode|downgrade}} method of the Draft module.
==Example==


{{Code|code=
<gallery widths="300" heights="200">
downgrade_list = downgrade(objects, delete=False, force=None)
File:Draft Downgrade 01.png|Complete shape
}}
File:Draft Downgrade 02.png|Downgraded shape, with disconnected and split faces
</gallery>


* {{incode|objects}} contains the objects to be downgraded. It is either a single object or a list of objects.
==Scripting==
* If {{incode|delete}} is {{incode|True}} the source objects are deleted.
* {{incode|force}} forces a certain way of downgrading by calling a specific internal function. It can be: {{incode|"explode"}}, {{incode|"shapify"}}, {{incode|"subtr"}}, {{incode|"splitFaces"}}, {{incode|"cut2"}}, {{incode|"getWire"}}, {{incode|"splitWires"}} or {{incode|"splitCompounds"}}.
* {{incode|downgrade_list}} is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. If {{incode|delete}} is {{incode|True}} the second list is empty.


Example:
The Downgrade tool can be used in python scripts and [[macros]] by using the following function:


{{Code|code=
<syntaxhighlight>
import FreeCAD as App
downgrade (objects [delete], [force])
import Draft
</syntaxhighlight>


doc = App.newDocument()
* Downgrades the given object(s) (can be an object or a list of objects).
* If delete is True, old objects are deleted.
* The force attribute can be used to force a certain way of downgrading. It can be: explode, shapify, subtr, splitFaces, cut2, getWire, splitWires.
* Returns a dictionnary containing two lists, a list of new objects and a list of objects to be deleted


circle = Draft.make_circle(1000)
Example:
rectangle = Draft.make_rectangle(2000, 800)
doc.recompute()


add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=True)
<syntaxhighlight>
import FreeCADGui,Draft
selection = FreeCADGui.Selection.getSelection()
Draft.downgrade(selection)
</syntaxhighlight>


compound = add_list1[0]
<languages/>
add_list2, delete_list2 = Draft.downgrade(compound, delete=False)
face = add_list2[0]
add_list3, delete_list3 = Draft.downgrade(face, delete=False)

box = doc.addObject("Part::Box", "Box")
box.Length = 2300
box.Width = 800
box.Height = 1000

add_list4, delete_list4 = Draft.downgrade(box, delete=True)

doc.recompute()
}}


{{Docnav
|[[Draft_Upgrade|Upgrade]]
|[[Draft_WireToBSpline|WireToBSpline]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Upgrade.svg
|IconR=Draft_WireToBSpline.svg
|IconC=Workbench_Draft.svg
}}

{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 20:06, 7 December 2023

Draft Downgrade

Menyplacering
Draft -> Downgrade
Arbetsbänkar
Draft, Arch
Standard genväg
D N
Introducerad i version
-
Se även
Draft Upgrade

Beskrivning

Detta verktyg nedgraderar valda objekt på olika sätt. Om inget objekt är markerat, så kommer du att ombes att välja ett.

Two overlapping faces are downgraded to a Part Cut object, which is downgraded to a face. That face is then downgraded to a closed wire, which is finally downgraded to separate edges.

Bruk

  1. Optionally select one or more objects.
  2. There are several ways to invoke the command:
    • Press the Downgrade button.
    • Select the Modification → Downgrade option from the menu.
    • Use the keyboard shortcut: D then N.
  3. If you have not yet selected an object: select an object in the 3D view.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To downgrade objects use the downgrade method of the Draft module.

downgrade_list = downgrade(objects, delete=False, force=None)
  • objects contains the objects to be downgraded. It is either a single object or a list of objects.
  • If delete is True the source objects are deleted.
  • force forces a certain way of downgrading by calling a specific internal function. It can be: "explode", "shapify", "subtr", "splitFaces", "cut2", "getWire", "splitWires" or "splitCompounds".
  • downgrade_list is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. If delete is True the second list is empty.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

circle = Draft.make_circle(1000)
rectangle = Draft.make_rectangle(2000, 800)
doc.recompute()

add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=True)

compound = add_list1[0]
add_list2, delete_list2 = Draft.downgrade(compound, delete=False)
face = add_list2[0]
add_list3, delete_list3 = Draft.downgrade(face, delete=False)

box = doc.addObject("Part::Box", "Box")
box.Length = 2300
box.Width = 800
box.Height = 1000

add_list4, delete_list4 = Draft.downgrade(box, delete=True)

doc.recompute()